## kunde 1.2009.6.23

=== Makefile ===
#POPCONFIG=$(CURDIR)/config.dist
## override this

include config.dist
export OWNER
export GROUP
export POPHOME=/usr/pop
export POPCONFIG=/etc/pop.conf
export POP=/pop
#export DATAHOST DATABASE

# Locales haben beim Bauen von Paketen etc. nix zu suchen.
export LANG=C
export LC_CTYPE=C
export LC_ALL=C
export LC_CTYPE=C
export LC_NUMERIC=C
export LC_TIME=C
export LC_COLLATE=C
export LC_MONETARY=C
export LC_MESSAGES=C
export LC_PAPER=C
export LC_NAME=C
export LC_ADDRESS=C
export LC_TELEPHONE=C
export LC_MEASUREMENT=C
export LC_IDENTIFICATION=C

SHELL=/bin/bash -e -o pipefail

VERSION := $(shell dpkg-parsechangelog -ldebian/changelog | sed -ne 's/^Version: *//p')

ifeq (,$(findstring release,$(DEB_BUILD_OPTIONS)))
VERS := test
else
VERS := kunde
endif

cc-option = $(shell if $(CC) $(1) -S -o /dev/null -xc /dev/null \
             > /dev/null 2>&1; then echo "$(1)"; else echo "$(2)"; fi ;)

export CFLAGS:=-O2 -g -DPOPCONFIG=\"$(POPCONFIG)\" \
	$(call cc-option,-Wno-pointer-sign)
export LANG=C
export LC_CTYPE=C

PERLLIBS:="$(CURDIR)/dbperl:$(CURDIR)/lib:$(CURDIR)/rt/lib:$(CURDIR)/htdocs/trouble-ticket/lib"

SUBPYTHON:=dbpython
SUBDIRS=lib dbperl test acct tools bin qsu cgi-bin kunde rt htdocs $(SUBPYTHON)
####### db templates
## 'db' ist das alte Kompatibilitätsding -- nicht mehr benötigt

TOPDIR=.

#all install clean obj:: # erstes Target ist Default...
#	@echo Using config file $(POPCONFIG)
#
all install obj:: noris
	mkdir -p obj

all:: python-stamp

test-stamp: noris
	$(MAKE) all
	$(MAKE) -C rt all
	touch test-stamp

python-stamp: noris dbpython/*.py
ifneq ($(SUBPYTHON),)
	python dbpython/setup.py build --build-lib=debian/build
	$(MAKE) -C tools all_p
endif
	touch python-stamp

clean::
	rm -rf obj
	rm -f noris lib/noris test/noris test-stamp
	rm -rf build

noris:
ifneq ($(SUBPYTHON),)
	cd test; rm -f noris; ln -s ../dbpython noris
	cd lib; rm -f noris; ln -s ../dbpython noris
	rm -f noris; ln -s dbpython noris
endif

obj/varsubst: obj $(CONFIG) Makefile 
	@ rm -f obj/varsubst
	@ ( echo MAILDOM=$(REAL_MAILDOM); echo POPHOME=$(POPHOME); echo POPCONFIG=$(POPCONFIG); echo RPM_PACKAGE_VERSION=${VERS}; echo RPM_PACKAGE_RELEASE=${VERSION};  ) \
	  | perl -ne 'chomp; if(s/^([0-9_A-Z]+)=//) { $$_ = $$ENV{$$1} if defined $$ENV{$$1}; print "s'"'"'\\\@$${1}\\\@'"'"'$$_'"'"';\n" } ' >$@
	@echo "'obj/varsubst' created."; echo ""

man:
	$(MAKE) -C bin man
	$(MAKE) -C tools man
	$(MAKE) -C dbperl man
	$(MAKE) -C rt man

install:: obj/varsubst
	install -o $(OWNER) -g $(GROUP) -m  755 -d $(DESTDIR)$(POPHOME)
	install -o $(OWNER) -g $(GROUP) -m 1773 -d $(DESTDIR)$(POPHOME)/tmp
	install -o $(OWNER) -g $(GROUP) -m  755 -d $(DESTDIR)$(POPHOME)/doc
	install -o $(OWNER) -g $(GROUP) -m  755 -d $(DESTDIR)$(POPHOME)/bin
	install -o $(OWNER) -g $(GROUP) -m  755 -d $(DESTDIR)$(POPHOME)/lib
	install -o $(OWNER) -g $(GROUP) -m  755 -d $(DESTDIR)$(POPHOME)/acct
	install -o $(OWNER) -g $(GROUP) -m  755 -d $(DESTDIR)$(POPHOME)/include
	install -o $(OWNER) -g $(GROUP) -m  770 -d $(DESTDIR)$(CACHEDIR)
	install -o $(OWNER) -g $(GROUP) -m  770 -d $(DESTDIR)$(LOGDIR)
	install -o $(OWNER) -g $(GROUP) -m  644 POP-Datenbank $(DESTDIR)$(POPHOME)
	echo ${VERSION} > $(DESTDIR)$(POPHOME)/VERSION
ifneq ($(SUBPYTHON),)
	$(MAKE) -C tools install_p
endif

all install diff::
	for i in $(SUBDIRS) ; do $(MAKE) -e TOPDIR=$(TOPDIR)/$$i -C $$i $@ ; done

clean::
	for i in $(SUBDIRS) ; do $(MAKE) -e TOPDIR=$(TOPDIR)/$$i -C $$i $@ || true; done

install::
	install -o root -g $(GROUP) -m  755 -d $(DESTDIR)/etc/init.d
	fn=/tmp/inst.$$$$; \
	for i in $$(git ls-files init); do \
		perl -p obj/varsubst <$$i >$$fn; \
		install -o root -g root -m 755 $$fn $(DESTDIR)/etc/init.d/kunde.$$(basename $$i); done; \
	rm $$fn

#	if test ! -f $(DESTDIR)/$(POPCONFIG) ; then \
#		fn=/tmp/inst.$$$$; \
#			perl -p obj/varsubst <config.dist >$$fn; \
#			install -o $(OWNER) -g $(GROUP) -m 640 $$fn $(DESTDIR)$(POPCONFIG) ; \
#		rm $$fn; \
#	fi

install:: python-stamp
ifneq ($(SUBPYTHON),)
	$(MAKE) -C dbpython install
endif
	

diff::
	echo Index: $(TOPDIR)/config
	-diff -bu config $(POPHOME)/config
	echo Index: $(TOPDIR)/POP-Datenbank
	-diff -bu POP-Datenbank $(POPHOME)/doc/POP-Datenbank

# Nicht getestet werden:
# Db/*.pm, die brauchen alle Datenbankzugriff
# Web*.pm, die brauchen Apache-Module

T=--modified --others
qtest: obj/varsubst noris
	rm -f obj/kunde_funcs
	$(MAKE) -C kunde
	@ptmp=/tmp/x.$$$$.pl; \
	ok=/tmp/ok.$$$$ ; touch $$ok; \
	err=/tmp/err.$$$$ ; \
	if test -z "$$TESTS" ; then \
	( git ls-files $T lib/acct kunde | egrep '^[a-z][^/]*(/[a-z][^/]*)*$$' ; \
	  git ls-files $T acct rt htdocs bin cgibin tools | egrep '^[a-z][^/]*(/[a-z][^/]*)*$$' | \
		xargs grep -l '^#!/usr/bin/perl'; \
	  git ls-files $T test | grep  '/[0-9][0-9]_' ; \
	  git ls-files $T htdocs rt dbperl | grep '\.p[lm]$$' | egrep -v '/(Db/|Web)' ) \
	else echo "$$TESTS" | xargs -n1 echo ; echo "" >&2; echo "" >&2; fi | \
		grep -v 'Makefile$$' | uniq | while read a ; do \
			test -f $$a || git checkout -- $$a; \
			if perl -p obj/varsubst <$$a >$$ptmp; env TESTING=1 KUNDE_NO_PERLPATH=1 POPCONFIG=$(CURDIR)/config.dist KUNDE=$(CURDIR)/kunde \
	PERL5LIB="$(CURDIR)/dbperl:$(CURDIR)/lib:$(CURDIR)/rt/lib:$(CURDIR)/htdocs/trouble-ticket/lib" \
	perl -c -Mstrict -Mwarnings $$ptmp >$$err 2>&1 ; then \
				: ; \
			else \
				rm -f $$ok ; \
			fi; \
			if test $$(grep -v "syntax OK" $$err | wc -l) -ne 0 ; then \
				echo -n "$$a: " ; cat $$err; \
				echo ""; \
			fi; \
		done  2>&1 | if test -z "$$TESTS" ; then less; else cat; fi; \
	rm -f $$ptmp $$err; \
	if test -f $$ok; then rm -f $$ok; else exit 1; fi

TESTHOST ?= $(shell if netcat -z localhost 3306 ; then echo localhost; else echo dev.office.noris.de; fi)
export TESTHOST

test:
	$(MAKE) clean
	$(MAKE) test-stamp
	$(MAKE) T="--cached --others" qtest
	$(MAKE) _rtest
rtest:
	$(MAKE) clean
	$(MAKE) test-stamp
	$(MAKE) _rtest

rrtest:
	$(MAKE) -C test
	@(if test -z "$$TESTS" ; then git ls-files -c -o test | sed -ne 's,^test/\([0-9][0-9]\)_,obj/test/\1_,p' | sort ; else echo "$$TESTS" | xargs -n1 echo | sed -e 's,^,obj/,' ; fi ) | \
	env TESTING3=1 REAL_TEST=1 POPCONFIG=$(CURDIR)/config.dist \
	perl -I/usr/share/kunde/trouble-ticket/lib -Mstrict -Mwarnings -MTest::Harness \
			-e 'my @t; while(<>) {chomp; push(@t,$$_);} runtests(@t);'
sstest:
	$(MAKE) -C test
	@(if test -z "$$TESTS" ; then git ls-files -c -o test | sed -ne 's,^test/\([0-9][0-9]\)_,obj/test/\1_,p' | sort ; else echo "$$TESTS" | xargs -n1 echo | sed -e 's,^,obj/,' ; fi ) | \
	while read t ; do echo "*** $$t ***"; \
	env TESTING3=1 TESTING4=1 REAL_TEST=1 POPCONFIG=$(CURDIR)/config.dist \
	perl -I/usr/share/kunde/trouble-ticket/lib -w -Mstrict -Mwarnings $$t ; echo ""; done \
	2>&1 | less "+/not ok"

ddtest:
	$(MAKE) -C test
	@(if test -z "$$TESTS" ; then git ls-files -c -o test | sed -ne 's,^test/\([0-9][0-9]\)_,obj/test/\1_,p' | sort ; else echo "$$TESTS" | xargs -n1 echo | sed -e 's,^,obj/,' ; fi ) | \
	while read t ; do echo "*** $$t ***"; \
	env TESTING3=1 TESTING4=1 REAL_TEST=1 POPCONFIG=$(CURDIR)/config.dist \
	perl -d -w -I/usr/share/kunde/trouble-ticket/lib -Mstrict -Mwarnings $$t ; echo ""; done 

_rtest:
	@(if test -z "$$TESTS" ; then git ls-files -c -o test | egrep '^test/[0-9][^/]*$$' | sort ; else echo "$$TESTS" | xargs -n1 echo ; fi ) | \
	env KUNDE_NO_PERLPATH=1 POPCONFIG=$(CURDIR)/config.dist KUNDE=$(CURDIR)/kunde TESTING3=1 PERL5LIB="$(PERLLIBS)" \
	perl -w -Mstrict -Mwarnings -MTest::Harness \
			-e 'my @t; while(<>) {chomp; push(@t,$$_);} runtests(@t);'
stest:
	$(MAKE) clean
	$(MAKE) test-stamp

	@(if test -z "$$TESTS" ; then git ls-files -c -o test | egrep '^test/[0-9][^/]*$$' | sort ; else echo "$$TESTS" | xargs -n1 echo ; fi ) | \
	while read t ; do echo "*** $$t ***"; \
	env KUNDE_NO_PERLPATH=1 POPCONFIG=$(CURDIR)/config.dist KUNDE=$(CURDIR)/kunde TESTING3=1 TESTING4=1 PERL5LIB="$(PERLLIBS)" \
	perl -w -Mstrict -Mwarnings $$t ; echo ""; done \
	2>&1 | less "+/not ok"

dtest:
	$(MAKE) clean
	$(MAKE) test-stamp

	@(if test -z "$$TESTS" ; then git ls-files -c -o test | egrep '^test/[0-9][^/]*$$' | sort ; else echo "$$TESTS" | xargs -n1 echo ; fi ) | \
	while read t ; do echo "*** $$t ***"; \
	env KUNDE_NO_PERLPATH=1 POPCONFIG=$(CURDIR)/config.dist KUNDE=$(CURDIR)/kunde PERL5LIB="$(PERLLIBS)" \
	perl -d -w -Mstrict -Mwarnings $$t ; echo ""; done 
ttest:
	$(MAKE) clean
	$(MAKE) test-stamp

	@(if test -z "$$TESTS" ; then git ls-files -c -o test | egrep '^test/[0-9][^/]*$$' | sort ; else echo "$$TESTS" | xargs -n1 echo ; fi ) | \
	while read t ; do echo "*** $$t ***"; \
	env KUNDE_NO_PERLPATH=1 POPCONFIG=$(CURDIR)/config.dist KUNDE=$(CURDIR)/kunde PERL5LIB="$(PERLLIBS)" \
	strace -f -s 300 perl -Mstrict -Mwarnings $$t ; echo ""; done 2>&1 | less

ditest:
	sh qsu/diff_run

atest: qtest rtest ditest

.PHONY: atest ditest _rtest test rtest stest qtest dtest all all_p install install_p diff noris

=== cgi-bin/Makefile ===
POPHOME=/tmp
OWNER=nobody
GROUP=none
CGIBIN=/usr/lib/cgi-bin/
SHELL=/bin/bash -e -o pipefail

WHAT=	check_flag_by_kunde.id \
	create_domain \
	get_email_by_user.name \
	get_hardware_by_kunde.id \
	get_ipassacct_by_kunde.id \
	get_kunde.id_by_user.name \
	get_kunden_by_user.name \
	get_radacct_by_kunde.id get_radacct_dienste_by_kunde.id \
	get_ticket_content_by_id get_tickets_by_user.name \
	get_unterkunden_by_kunde.id \
	get_trouble_ticket get_trouble_tickets_by_kunde.id \
	printenv

all:
	# nix
clean:

install:
	install -o $(OWNER) -g $(GROUP) -m 755 -d $(DESTDIR)$(CGIBIN)
	fn=/tmp/inst.$$$$; \
	for i in $(WHAT) ; do \
		perl -p ../obj/varsubst <$$i >$$fn; \
		install -o $(OWNER) -g $(GROUP) -m 755 $$fn $(DESTDIR)$(CGIBIN)/$$i ; \
	done; \
	rm -f $$fn

diff:
	for i in $(WHAT) ; do \
		echo Index: $(TOPDIR)/$$i; \
		perl -p ../obj/varsubst <$$i | diff -bu - $(CGIBIN)$$i || true ; \
	done

.PHONY: all install diff

=== db/Makefile ===

### Makefile for the database stuff
POPHOME=/tmp
DATABASE=dummy
OWNER=nobody
GROUP=none
SHELL=/bin/bash -e -o pipefail

ALLPROGS=dbaselnx dbasepg dbasedummy dbasemsql dbasemysql
PROGS=dbase$(DATABASE)
all: $(addprefix ../obj/,$(PROGS))

install: all
	cd ../obj; install -o $(OWNER) -g $(GROUP) -m 755 $(PROGS) $(DESTDIR)$(POPHOME)/lib

diff:

clean:
	rm -f ../obj/*.o $(addprefix ../obj/,$(ALLPROGS))

../obj/db_dummy.o: db_dummy.c dbase.h
	 $(CC) $(CFLAGS) -c -o $@ $<

../obj/db_mysql.o: db_mysql.c dbase.h
	 $(CC) $(CFLAGS) -I /usr/include/mysql -c -o $@ $<

../obj/db_msql.o: db_msql.c dbase.h
	 $(CC) $(CFLAGS) -I /usr/lib/msql/include -c -o $@ $<

../obj/db_lnx.o: db_lnx.c dbase.h
	 $(CC) $(CFLAGS) -c -o $@ $<

../obj/db_pg.o: db_pg.c dbase.h
	$(CC) $(CFLAGS) -c $< -I/usr/postgres/include -o $@

../obj/dbase.o: dbase.c dbase.h
	 $(CC) $(CFLAGS) -c -o $@ $<

../obj/dbasemysql: ../obj/dbase.o ../obj/db_mysql.o
	$(CC) $(LDFLAGS) -o $@ $^ -L/usr/lib/mysql -lmysqlclient -lpthread

../obj/dbasemsql: ../obj/dbase.o ../obj/db_msql.o
	$(CC) $(LDFLAGS) -o $@ $^ -L/usr/lib/msql/lib -lmsql

../obj/dbasepg: ../obj/dbase.o ../obj/db_pg.o
	$(CC) $(LDFLAGS) -o $@ $^ -L/usr/postgres/lib -lpq

../obj/dbasedummy: ../obj/dbase.o ../obj/db_dummy.o
	$(CC) $(LDFLAGS) -o $@ $^

../obj/dbaselnx: ../obj/dbase.o ../obj/db_lnx.o
	$(CC) $(LDFLAGS) -o $@ $^ /usr/lib/lnx/esql/sql.o

=== dbperl/Makefile ===
POPHOME=/tmp ## override!
OWNER=nobody
GROUP=none
SHELL=/bin/bash -e -o pipefail

DBP=$(wildcard Dbase/*.pm)
DBE=Cf.pm
DBA=$(filter-out ${DBE}, $(wildcard *.pm))
DBF=$(shell find noris Net HousingDB -name \*.pm)
DBM=$(wildcard MIME/*.pm)

V=$(shell cd ..; dpkg-parsechangelog | sed -ne 's/^Version:\s*//p')

man:
	mkdir -p $(DESTDIR)/usr/share/man/man3
	find * \( -name \*.pm -o -name \*.pod \) -print | xargs grep -l =head | while read a ; do \
		iconv -f utf8 -t latin1 $$a | grep -v "^=encoding utf8" | pod2man -c Kunde -s 3 -q "''" -r $V -v | gzip -9 > $(DESTDIR)/usr/share/man/man3/$$(echo $$a | sed -e "s/\.p\(m\|od\)$$//" -e s,/,::,g).3.gz ; \
	done

all clean:

install:
	find . -type d -print | while read d ; do \
		install -o $(OWNER) -g $(GROUP) -m 755 -d $(DESTDIR)$(POPHOME)/lib/$$d; \
		done

	fn=/tmp/inst.$$$$; \
	for i in $(DBA) ; do \
		perl -p ../obj/varsubst <$$i >$$fn; \
		install -o $(OWNER) -g $(GROUP) -m 755 $$fn $(DESTDIR)$(POPHOME)/lib/$$i ; \
	done; \
	rm -f $$fn

	fn=/tmp/inst.$$$$; \
	for i in $(DBP) ; do \
		perl -p ../obj/varsubst <$$i >$$fn; \
		install -o $(OWNER) -g $(GROUP) -m 755 $$fn $(DESTDIR)$(POPHOME)/lib/$$i ; \
	done; \
	rm -f $$fn

	fn=/tmp/inst.$$$$; \
	for i in $(DBF) ; do \
		perl -p ../obj/varsubst <$$i >$$fn; \
		install -o $(OWNER) -g $(GROUP) -m 755 $$fn $(DESTDIR)$(POPHOME)/lib/$$i ; \
	done; \
	rm -f $$fn

	fn=/tmp/inst.$$$$; \
	for i in $(DBE) ; do \
		perl -p ../obj/varsubst <$$i >$$fn; \
		install -o $(OWNER) -g $(GROUP) -m 755 $$fn $(DESTDIR)$(POPHOME)/lib/$$i ; \
	done; \
	rm -f $$fn

	fn=/tmp/inst.$$$$; \
	for i in $(DBM) ; do \
		perl -p ../obj/varsubst <$$i >$$fn; \
		install -o $(OWNER) -g $(GROUP) -m 755 $$fn $(DESTDIR)$(POPHOME)/lib/$$i ; \
	done; \
	rm -f $$fn

diff:
	-for i in $(DBA) $(DBE) $(DBP) $(DBF) $(DBM); do \
		echo Index: $(TOPDIR)/$$i; \
		perl -p ../obj/varsubst <$$i | diff -bu - $(POPHOME)/lib/$$i; done

=== htdocs/Makefile ===
POPHOME=/usr/pop
OWNER=nobody
GROUP=none
SHELL=/bin/bash -e -o pipefail

DEST=${DESTDIR}/usr/share/kunde

compile all:
	@echo Nix zu tun.

install:
	find * -iname [a-z]\* -type d -print -o -prune | \
		while read a ; do install -d ${DEST}/"$$a"; done

	fn=/tmp/inst.$$$$; \
	find * -iname [a-z]\* -o -prune | grep -v '\.js$$' | \
		while read a ; do \
			if [ -f "$$a" ] ; then \
				perl -p ../obj/varsubst <$$a >$$fn; \
				install -o $(OWNER) -g $(GROUP) -m 755 $$fn $(DEST)/"$$a" ;\
			fi ; \
		done; \
		rm $$fn
	find * -iname [a-z]\*.js | \
		while read a ; do \
			install -o $(OWNER) -g $(GROUP) -m 755 $$a $(DEST)/"$$a" ; \
		done

clean:
	# nothing to do

=== qsu/Makefile ===
POPHOME=/tmp
OWNER=nobody
GROUP=none
SHELL=/bin/bash -e -o pipefail

WHAT=build_it copy_rechlauf db.rechlauf gen_tests kunde_builder rldumper sync_db test.ticketgen

V=$(shell cd ..; dpkg-parsechangelog | sed -ne 's/^Version:\s*//p')

man:
	mkdir -p $(DESTDIR)/usr/share/man/man1
	grep -l '^#!/usr/bin/perl' * | xargs grep -l ^=head | while read a ; do \
		iconv -f utf8 -t latin1 $$a | pod2man -c Kunde -s 1 -q "''" -r $V -v | gzip -9 > $(DESTDIR)/usr/share/man/man1/$$a.1.gz ; \
	done

clean:

install:
	install -o $(OWNER) -g $(GROUP) -m 755 -d $(DESTDIR)$(POPHOME)/bin
	fn=/tmp/inst.$$$$; \
	for i in $(WHAT) ; do \
		perl -p ../obj/varsubst <$$i >$$fn; \
		install -o $(OWNER) -g $(GROUP) -m 755 $$fn $(DESTDIR)$(POPHOME)/bin/$$i ; \
	done; \
	rm -f $$fn

diff:
	for i in $(WHAT) ; do \
		echo Index: $(TOPDIR)/$$i; \
		perl -p ../obj/varsubst <$$i | diff -bu - $(POPHOME)/bin/$$i || true ; \
	done

.PHONY: all all_p install install_p diff

=== rt/Makefile ===
# $Header: /usr/local/cvsroot/rt/Makefile,v 1.47 1998/09/08 07:18:54 jesse Exp $
# 
#
# Request Tracker is Copyright 1997 Jesse Reed Vincent <jesse@fsck.com>
# RT is distribute under the terms of the GNU Public License
#
SHELL=/bin/bash -e -o pipefail

include ../config.dist
export OWNER
export GROUP
export DOC=/usr/share/Datenbank
export POPHOME=/usr/pop
export POPCONFIG=/etc/pop.conf
export POP=/pop
#export DATAHOST DATABASE

CC			=	gcc
PERL			= 	/usr/bin/perl
RTUSER			=	$(OWNER)
RTGROUP			=	$(GROUP)

RT_VERSION_MAJOR	=	0
RT_VERSION_MINOR	=	9
RT_VERSION_PATCH	=	18

RT_VERSION =	$(RT_VERSION_MAJOR).$(RT_VERSION_MINOR).$(RT_VERSION_PATCH).noris

#
# RT_PATH is the name of the directory you want make to install RT in
#

RT_PATH			=	/usr/pop/rt

#
# The rest of these paths are all configurable, but you probably don't want to 
# put them elsewhere
#

RT_LIB_PATH		=	/usr/pop/lib
RT_ETC_PATH		=	$(RT_PATH)/etc
RT_BIN_PATH		=	$(RT_PATH)/bin
RT_HTDOCS_PATH		=	/www/htdocs
#RT_TRANSACTIONS_PATH	= 	$(RT_PATH)/transactions

# Where you keep the templates for your various queues
#RT_TEMPLATE_PATH	=	$(RT_ETC_PATH)/templates


#
# The rtmux is the setuid script which invokes whichever rt program it needs to.
#

RT_PERL_DAILY		=	$(RT_BIN_PATH)/rt.daily
RT_PERL_MUX		=	$(RT_BIN_PATH)/rtmail
RT_PERL		=	$(RT_LIB_PATH)/RT/Web.pm
#RT_WRAPPER		=	$(RT_BIN_PATH)/rtmail

#
# The following are the names of the various binaries which make up RT 
#
RT_ACTION_BIN		=	rt
RT_QUERY_BIN		=	rtq
RT_ADMIN_BIN		=	rtadmin
RT_MAILGATE_BIN		=	rt-mailgate
RT_WEB_QUERY	=	nph-webrt
RT_WEB_ADMIN	=	nph-admin-webrt
RT_WEB_QUERY_BIN	=	nph-webrt.cgi
RT_WEB_ADMIN_BIN	=	nph-admin-webrt.cgi


default:
	$(MAKE) -f Makefile.Linux install
	cp /dev/null /var/log/rt
	#@echo "Read the readme"

../obj/varsubst:
	$(MAKE) -C .. $@

#install: dirs mux-install libs-install initialize config-replace httpd.conf-replace nondestruct instruct htdocs
WHAT=rt-queue_stats wikiseite4kunde
install: dirs upgrade config-replace mux-install libs-install ../obj/varsubst
	mkdir -p $(DESTDIR)/etc/init.d
	install -o root -m 755 config.Linux $(DESTDIR)/etc/init.d/rt
	install -d $(DESTDIR)/usr/share/kunde/rt
	install -d $(DESTDIR)/usr/share/kunde/rt/volltextsuche
	install volltextsuche/* $(DESTDIR)/usr/share/kunde/rt/volltextsuche
	install -d $(DESTDIR)/etc/apache-ssl
	install -d $(DESTDIR)/etc/apache2
	install etc/startup-apache2.pl $(DESTDIR)/etc/apache2/startup.pl
	fn=/tmp/inst.$$$$; \
	for i in $(WHAT) ; do \
			perl -p ../obj/varsubst <bin/$$i >$$fn; \
			install -o $(OWNER) -g $(GROUP) -m 755 $$fn $(DESTDIR)/usr/share/kunde/rt/$$i ; \
	done; \
	rm -f $$fn
	install -d $(DESTDIR)/usr/share/kunde/rt/images
	install images/* $(DESTDIR)/usr/share/kunde/rt/images
	install rt-spalten.html $(DESTDIR)/usr/share/kunde/rt


#suid-wrapper: $(RT_WRAPPER)
#	echo EQUALCP $(RT_WRAPPER)
#$(RT_WRAPPER): bin/suidrt.c
#	$(CC) bin/suidrt.c -DPERL=\"$(PERL)\" -DRT_PERL_MUX=\"$(RT_PERL_MUX)\" -o $(RT_WRAPPER)
#
instruct:
	@echo "Congratulations. RT has been installed. "
	@echo "(Now, create a queue, add some users and start resolving requests)"

upgrade: libs-install config-replace mux-install nondestruct

nondestruct: fixperms

all:
#	$(PERL) -p -e "\
#	s'!!RT_PATH!!'$(RT_PATH)'g;\
#        s'!!RTUSER!!'$(RTUSER)'g;\
#        s'!!RTGROUP!!'$(RTGROUP)'g;\
#        s'!!RT_MYSQL_PASS!!'$(RT_MYSQL_PASS)'g;\
#        s'!!RT_MAIL_TAG!!'$(RT_MAIL_TAG)'g;\
#	s'!!RT_USER_PASSWD_MIN!!'$(RT_USER_PASSWD_MIN)'g;\
#        s'!!RT_MYSQL_HOST!!'$(RT_MYSQL_HOST)'g;\
#        s'!!RT_MYSQL_DATABASE!!'$(RT_MYSQL_DATABASE)'g;\
#        s'!!RT_MAIL_ALIAS!!'$(RT_MAIL_ALIAS)'g;\
#	s'!!MYSQL_VERSION!!'$(MYSQL_VERSION)'g; " <etc/config.pm >lib/RT/config.pm
#
fixperms:
	# chown -R $(RTUSER).$(RTGROUP) $(DESTDIR)$(RT_PATH)/.
	# chmod -R 0755 $(DESTDIR)$(RT_LIB_PATH)
	# chmod -R 0770 $(DESTDIR)$(RT_ETC_PATH)
	# chmod 0755 $(DESTDIR)$(RT_PATH)
	# chmod 0755 $(DESTDIR)$(RT_BIN_PATH)
	# chmod 0755 $(DESTDIR)$(RT_CGI_PATH)
	# chmod 0755 $(DESTDIR)$(RT_PERL_MUX)
#	chmod 0755 $(DESTDIR)$(RT_PERL_DAILY)
	# chmod 0755 $(DESTDIR)$(RT_PERL)
#	chmod 4111 $(DESTDIR)$(RT_WRAPPER)

dirs:
	install -d -o $(RTUSER) -m 755 $(DESTDIR)$(RT_BIN_PATH)
	install -d -o $(RTUSER) -m 755 $(DESTDIR)$(RT_ETC_PATH)
#	install -d -o $(RTUSER) -m 755 $(DESTDIR)$(RT_ETC_PATH)/RT
#	install -o $(RTUSER) -m 755 ./etc/* $(DESTDIR)$(RT_ETC_PATH)
#	mkdir -p $(DESTDIR)$(RT_TRANSACTIONS_PATH)

libs-install: 
	install -d -o $(RTUSER) -m 755 $(DESTDIR)$(RT_LIB_PATH)
	cd lib; find RT RT.pm -type d | fgrep -v /.git | while read a ; do install -o $(RTUSER) -m 755 -d $(DESTDIR)$(RT_LIB_PATH)/$$a; done
	cd lib; find RT RT.pm -type f | fgrep -v /.git | while read a ; do install -o $(RTUSER) -m 644 $$a $(DESTDIR)$(RT_LIB_PATH)/$$a ; done

diff:
	cd lib; find RT RT.pm -type f | grep -v /.git | while read a ; do perl -p ../../obj/varsubst <$$a | diff -bu - $(RT_LIB_PATH)/$$a ; done

initialize: database acls


database:
#	$(MYSQLDIR)/mysqladmin drop $(RT_MYSQL_DATABASE)
	-$(MYSQLDIR)/mysqladmin create $(RT_MYSQL_DATABASE)
	$(MYSQLDIR)/mysql $(RT_MYSQL_DATABASE) < etc/schema      

acls:
	-$(PERL) -p -e "if ('$(RT_MYSQL_HOST)' eq '') { s'!!RT_MYSQL_HOST!!'localhost'g}\
			else { s'!!RT_MYSQL_HOST!!'$(RT_MYSQL_HOST)'g }\
		s'!!RT_MYSQL_PASS!!'$(RT_MYSQL_PASS)'g;\
		s'!!RTUSER!!'$(RTUSER)'g;\
		s'!!RT_MYSQL_DATABASE!!'$(RT_MYSQL_DATABASE)'g;\
		" $(RT_MYSQL_ACL) | $(MYSQLDIR)/mysql mysql
	$(MYSQLDIR)/mysqladmin reload


mux-install: ../obj/varsubst
	$(PERL) -p -e "s'!!RT_PATH!!'$(RT_PATH)'g;\
			      	s'!!RT_VERSION!!'$(RT_VERSION)'g;\
				s'!!RT_ACTION_BIN!!'$(RT_ACTION_BIN)'g;\
				s'!!RT_QUERY_BIN!!'$(RT_QUERY_BIN)'g;\
				s'!!RT_ADMIN_BIN!!'$(RT_ADMIN_BIN)'g;\
				s'!!RT_MAILGATE_BIN!!'$(RT_MAILGATE_BIN)'g;\
				s'!!RT_WEB_QUERY_BIN!!'$(RT_WEB_QUERY_BIN)'g;\
				s'!!RT_WEB_ADMIN_BIN!!'$(RT_WEB_ADMIN_BIN)'g;\
				s'!!RT_WEB_QUERY!!'$(RT_WEB_QUERY)'g;\
				s'!!RT_WEB_ADMIN!!'$(RT_WEB_ADMIN)'g;\
				s'!!POPHOME!!'$(POPHOME)'g;\
				s'!!RT_ETC_PATH!!'$(RT_ETC_PATH)'g;\
				s'!!RT_LIB_PATH!!'$(RT_LIB_PATH)'g;" < bin/rtmail.pl | \
				        perl -p ../obj/varsubst > /tmp/rtm.$$$$ ; \
				install -o $(RTUSER) -m 755 /tmp/rtm.$$$$ $(DESTDIR)$(RT_PERL_MUX) ; \
				rm -f /tmp/rtm.$$$$

	$(PERL) -p -e "s'!!RT_PATH!!'$(RT_PATH)'g;\
			      	s'!!RT_VERSION!!'$(RT_VERSION)'g;\
				s'!!RT_ACTION_BIN!!'$(RT_ACTION_BIN)'g;\
				s'!!RT_QUERY_BIN!!'$(RT_QUERY_BIN)'g;\
				s'!!RT_ADMIN_BIN!!'$(RT_ADMIN_BIN)'g;\
				s'!!RT_MAILGATE_BIN!!'$(RT_MAILGATE_BIN)'g;\
				s'!!RT_WEB_QUERY_BIN!!'$(RT_WEB_QUERY_BIN)'g;\
				s'!!RT_WEB_ADMIN_BIN!!'$(RT_WEB_ADMIN_BIN)'g;\
				s'!!RT_WEB_QUERY!!'$(RT_WEB_QUERY)'g;\
				s'!!RT_WEB_ADMIN!!'$(RT_WEB_ADMIN)'g;\
				s'!!POPHOME!!'$(POPHOME)'g;\
				s'!!RT_ETC_PATH!!'$(RT_ETC_PATH)'g;\
				s'!!RT_LIB_PATH!!'$(RT_LIB_PATH)'g;" < bin/rt.daily | \
				        perl -p ../obj/varsubst > /tmp/rtm.$$$$ ; \
				install -o $(RTUSER) -m 755 /tmp/rtm.$$$$ $(DESTDIR)$(RT_PERL_DAILY) ; \
				rm -f /tmp/rtm.$$$$

config-replace:
#        s'!!RT_TRANSACTIONS_PATH!!'$(RT_TRANSACTIONS_PATH)'g;\
#        s'!!RT_TEMPLATE_PATH!!'$(RT_TEMPLATE_PATH)'g;\

httpd.conf-replace:
	-mv $(RT_ETC_PATH)/httpd/cern/httpd.conf $(DESTDIR)$(RT_ETC_PATH)/httpd/cern/httpd.conf.old
	install ./etc/httpd/cern/httpd.conf $(DESTDIR)$(RT_ETC_PATH)/httpd/cern
	$(PERL) -p -i -e "\
        s'!!RTUSER!!'$(RTUSER)'g;\
        s'!!RTGROUP!!'$(RTGROUP)'g;\
        s'!!HTTPD_PORT!!'$(HTTPD_PORT)'g;\
        s'!!HTTPD_ROOT!!'$(HTTPD_ROOT)'g;\
        s'!!HTTPD_ERROR_LOG!!'$(HTTPD_ERROR_LOG)'g;\
        s'!!HTTPD_ACCESS_LOG!!'$(HTTPD_ACCESS_LOG)'g;\
        s'!!RT_CGI_PATH!!'$(RT_CGI_PATH)'g;\
        s'!!HTTPD_IMAGES_PATH!!'$(HTTPD_IMAGES_PATH)'g;\
        s'!!HTTPD_CGI_PREFIX!!'$(HTTPD_CGI_PREFIX)'g; " $(DESTDIR)$(RT_ETC_PATH)/httpd/cern/httpd.conf

dist:
	cvs commit
	cvs tag -F rt-$(RT_VERSION_MAJOR)-$(RT_VERSION_MINOR)-$(RT_VERSION_PATCH)
	rm -rf /tmp/rt-$(RT_VERSION)
	cvs export -D now -d /tmp/rt-$(RT_VERSION) rt
	cd /tmp; tar czvf /home/ftp/pub/rt/devel/rt-$(RT_VERSION).tar.gz rt-$(RT_VERSION)/
	cd /home/ftp/pub/rt/devel/
	rm -rf ./rt.tar.gz
	ln -s ./rt-$(RT_VERSION).tar.gz ./rt.tar.gz
	chmod 644 /home/ftp/pub/rt/devel/rt-$(RT_VERSION).tar.gz

htdocs:
	install -d $(DESTDIR)$(RT_HTDOCS_PATH)
	install lib/htdocs/rt-spalten.html $(DESTDIR)$(RT_HTDOCS_PATH)

man:
	mkdir -p $(DESTDIR)/usr/share/man/man3
	cd lib; find . -name SCCS -prune -o -name \*.pm -print | ( xargs grep -l =head || true ) | while read a ; do \
		iconv -f utf8 -t latin1 $$a | pod2man -c Kunde -s 3 -q "''" -r $V -v | gzip -9 > $(DESTDIR)/usr/share/man/man3/$$(echo $$a | sed -e s,/,::,g).3.gz ; \
	done

clean:
	# nothing to do

=== test/Makefile ===

###
### Makefile für den Xlink-POP-Datenbankbetrieb oder was auch immer.
###

POPHOME=/tmp
OWNER=nobody
GROUP=none
SHELL=/bin/bash -e -o pipefail

CFLAGS=-O2

ALL:=$(wildcard ??_*)

all:
	$(MAKE) -C .. obj/varsubst
	mkdir -p ../obj/test
	fn=/tmp/inst.$$$$; \
	for i in $(ALL) ; do \
		perl -p ../obj/varsubst <$$i >../obj/test/$$i; \
	done; \
	rm -f $$fn

clean:

V=$(shell cd ..; dpkg-parsechangelog | sed -ne 's/^Version:\s*//p')

man:
	mkdir -p $(DESTDIR)/usr/share/man/man1
	grep -l '^#!/usr/bin/perl' * | xargs grep -l ^=head | while read a ; do \
		iconv -f utf8 -t latin1 $$a | pod2man -c Kunde -s 1 -q "''" -r $V -v | gzip -9 > $(DESTDIR)/usr/share/man/man1/$$a.1.gz ; \
	done


install:

diff:

=== tools/Makefile ===
POPHOME=/usr/pop
OWNER=nobody
GROUP=none
SHELL=/bin/bash -e -o pipefail

WHAT= \
	acct.postfaecher \
	acctdiff \
	arbeitszeit4tickets \
	arbeitszeit-acct \
	beendete_kunden \
	check.accounting_up-to-dateness \
	check_db_chars \
	check.dns-zones \
	check_domain_expiries.ch_li \
	check_domain_expiries_by_whois \
	check_rt-tickets \
	check_rtticket_freshness \
	check_rtticket_freshness \
	collect_rt-queue_stats \
	db_seqnum \
	dbdiff dbdiffreport \
	dbping \
	dbstatus \
	dbtree \
	delete_old_acct \
	diff.hardware \
	dispatch.win-sec-ssc \
	domainliste \
	domainlose_webspaces \
	domainlose_webspaces \
	export.personen4ldap \
	extract_networks_from_bgp-table \
	find_descr \
	find_missing_domains \
	find_overlaps \
	finde_0 \
	finde_kunden_mit_mehreren_volumentarifen \
	fnbatcher \
	geburtstage \
	geistertraffic \
	gen.ablauf \
	gen.adressplan \
	gen.assoz \
	gen.descr \
	gen.dhcpconf \
	gen.domain \
	gen.eximconf \
	gen.fdzliste \
	gen.ip \
	gen.hostlist \
	gen.hostlist4standorte \
	gen.kunden_ohne_tarife_ausser \
	gen.kundedomains \
	gen.kundenliste \
	gen.mailusers \
	gen.nagioscontactgroups \
	gen.nagiosservices4leitungen \
	gen.oxconf \
	gen.radius \
	gen.testrechnungsdiff \
	gen.user \
	gen.virtualhosts \
	gen.vmps \
	gen.wice_liste \
	get.domainkosten \
	get.umsatz4kunde \
	get_backup_volume \
	get_domainlist_from_partnergate \
	get_domainlist_from_switch \
	get_tickets \
	hardwareliste \
	hotline-einsaetze \
	idndig \
	ipacct \
	ipcalc \
	iplog \
	logserver \
	lohnbuchen2 \
	look4rt-tickets \
	kunden_nach_vertrieblichen_ansprechpartnern \
	maile.neue_hardware \
	maile.rt-billing2ap \
	maile.stunden \
	makedomains \
	manage.mysql-databases \
	mda.dsl-tt \
	mig.2dienst \
	mig.ablauf \
	mig.strings \
	mig.testsystem \
	mig.update_stunden \
	nsset \
	obsolete_FQDNs \
	print-all \
	pruefe_ustids \
	rech \
	remind_hardware_standorte \
	remind_pending_tts \
	rt-eskalation \
	set_ds_keyword \
	show_domains \
	sshpipe \
	stunden-statistik \
	suche_reminder-ticket \
	ticketgen \
	trans.kunde \
	ueberpruefe_mailrules \
	ueberstunden \
	urlaubsstand \
	umsatzliste \
	umsatzplanung \
	update.domains.partnergate \
	wakeup \
	wice2pop.kprios \
	zeitstatistik \

override CFLAGS := $(CFLAGS) -Wall -D_GNU_SOURCE
LDLIBS=-L../obj -L$(POPHOME)/lib -Wl,-rpath,$(POPHOME)/lib 

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_GNU_SYSTEM ?= $(shell dpkg-architecture -qDEB_HOST_GNU_SYSTEM)

ifeq ($(DEB_HOST_ARCH),i386)
OBINS=../obj/ripe2cidr64 ../obj/logsplit64
build_64_target = x86_64-$(DEB_HOST_GNU_SYSTEM)
endif
ifeq ($(DEB_HOST_ARCH),amd64)
OBINS=../obj/ripe2cidr32 ../obj/logsplit32
build_32_target = i486-$(DEB_HOST_GNU_SYSTEM)
endif

all:  ../obj/ripe2cidr ../obj/logsplit $(OBINS)
all_p: ../obj/sql_diff

V=$(shell cd ..; dpkg-parsechangelog | sed -ne 's/^Version:\s*//p')

man:
	mkdir -p $(DESTDIR)/usr/share/man/man1
	grep -l '^#!/usr/bin/perl' * | xargs grep -l ^=head | while read a ; do \
		iconv -f utf8 -t latin1 $$a | pod2man -c Kunde -s 1 -q "''" -r $V -v | gzip -9 > $(DESTDIR)/usr/share/man/man1/$$a.1.gz ; \
	done

clean:
	rm -f ../obj/ripe2cidr ../obj/logsplit ../obj/*.o

../obj/logsplit: ../obj/logsplit.o
	$(CC) -g -o $@ $(filter-out %.a %.so,$^) $(LDLIBS)

../obj/ripe2cidr: ../obj/ripe2cidr.o
	$(CC) -g -o $@ $(filter-out %.a %.so,$^)

../obj/logsplit64: ../obj/logsplit64.o
	$(CC) -m64 -g -o $@ $(filter-out %.a %.so,$^) $(LDLIBS)

../obj/ripe2cidr64: ../obj/ripe2cidr64.o
	$(CC) -m64 -g -o $@ $(filter-out %.a %.so,$^)

../obj/logsplit32: ../obj/logsplit32.o
	$(CC) -m32 -g -o $@ $(filter-out %.a %.so,$^) $(LDLIBS)

../obj/ripe2cidr32: ../obj/ripe2cidr32.o
	$(CC) -m32 -g -o $@ $(filter-out %.a %.so,$^)

../obj/%.o: %.c
	$(CC) $(CFLAGS) -c -o $@ $^

../obj/%32.o: %.c
	$(CC) -m32 $(CFLAGS) -c -o $@ $^

../obj/%64.o: %.c
	$(CC) -m64 $(CFLAGS) -c -o $@ $^

../obj/sql_diff: sql_diff.g
	yapps $^ $@ || cp sql_diff.not $@
	chmod +x $@

install:
	install -o $(OWNER) -g $(GROUP) -m 755 -d $(DESTDIR)$(POPHOME)/bin
	install -o $(OWNER) -g $(GROUP) -m 755 -d $(DESTDIR)$(POPHOME)/lib
	install -o $(OWNER) -g $(GROUP) -m 755 ../obj/ripe2cidr $(DESTDIR)$(POPHOME)/bin
	install -o $(OWNER) -g $(GROUP) -m 755 ../obj/logsplit $(DESTDIR)$(POPHOME)/bin
ifneq ($(OBINS),)
	install -o $(OWNER) -g $(GROUP) -m 755 $(OBINS) $(DESTDIR)$(POPHOME)/bin
endif
	install -o root -g root -m 755 -d $(DESTDIR)/usr/sbin
	install -o root -g root -m 755 -d $(DESTDIR)/usr/bin

	fn=/tmp/inst.$$$$; \
	for i in $(WHAT) ; do \
		perl -p ../obj/varsubst <$$i >$$fn; \
		install -o $(OWNER) -g $(GROUP) -m 755 $$fn $(DESTDIR)$(POPHOME)/bin/$$i ; \
	done; \
	perl -p ../obj/varsubst <logclient >$$fn; \
	install -o root -g root -m 755 $$fn $(DESTDIR)/usr/sbin/logclient; \
	rm -f $$fn

install_p: all_p
	install -o root -g root -m 755 -d $(DESTDIR)/usr/bin
	install -o root -g root -m 755 ../obj/sql_diff $(DESTDIR)$(POPHOME)/bin

diff:
	for i in $(WHAT) ; do \
		echo Index: $(TOPDIR)/$$i; \
		perl -p ../obj/varsubst <$$i | diff -bu - $(POPHOME)/bin/$$i || true ; \
	done

.PHONY: all all_p install install_p diff

=== debian/changelog ===
kunde (1.2009.6.23) unstable; urgency=low

  * Neue Version...
  * #10056572: Bugfix für Suche nach FQDN unter "alle Kunden"

 -- Martin H. Sluka <fany@noris.net>  Tue, 06 Oct 2009 14:52:23 +0200

kunde (1.2009.6.22) unstable; urgency=low

  * Neue Version...
  * #10056543: rt-eskalation: relative Zeiten aus QSU-Tests entfernt

 -- Martin H. Sluka <fany@noris.net>  Tue, 06 Oct 2009 14:30:57 +0200

kunde (1.2009.6.21) unstable; urgency=low

  * #547917: TT-Generator: Selektion von Kunden mit Hardware im RZ3 und
    RZ4 ermöglicht
  * #10054635: stunden-statistik: Aufruf arbeitszeit4tickets korrigiert

 -- Martin H. Sluka <fany@noris.net>  Tue, 06 Oct 2009 12:21:07 +0200

kunde (1.2009.6.20) unstable; urgency=low

  * #10055524: SQL-Fehler bei alleKunden in edit/domains, list/vrfs behoben
  * #10056295: Bei Kundentarifen "lt" - wird keine TarifId angezeigt

 -- Stelios Gikas <stelios.gikas@noris.net>  Mon, 05 Oct 2009 18:20:25 +0200

kunde (1.2009.6.19) unstable; urgency=low

  * Neue Version...

 -- Martin H. Sluka <fany@noris.net>  Mon, 05 Oct 2009 11:58:01 +0200

kunde (1.2009.6.18) unstable; urgency=low

  * Neue Version...
  * #10055393: Dbase::Ticket: Verbindungs-Pool der Ticket-API nutzen

 -- Martin H. Sluka <fany@noris.net>  Mon, 05 Oct 2009 11:45:15 +0200

kunde (1.2009.6.17) unstable; urgency=low

  * #10054635: stunden-statistik: Pfad zu arbeitszeit4tickets ergänzt
  * #10050109: kunde: Bugfix wenn IP-Objekt keinen Owner hatte gabs Probleme

 -- Stelios Gikas <stelios.gikas@noris.net>  Thu, 01 Oct 2009 16:14:11 +0200

kunde (1.2009.6.16) unstable; urgency=low

  * #10032057: Beispiel-Template hostextinfo-common zu gen.hostlist:
    Doppelnennungen vermeiden
  * acct.info: fehlende Tabellennamen in der Sortierung
  * #10054635: stunden-statistik: Fix Encoding-Problem ("use utf8")

 -- Martin H. Sluka <fany@noris.net>  Wed, 30 Sep 2009 18:55:36 +0200

kunde (1.2009.6.15) unstable; urgency=low

  * #465235: Dbase::Ticket->owner aka ->bearbeiter als Dbase::Person-Objekt
  * #10022069: Fehler werfen bei "l #...", wenn "..." unbekannt ist
  * #465235: rt-eskalation: "-ohne-status merged" als Default
  * #465235: rt-eskalation: Bugfix für "-ohne-bearbeiter ''"
  * #465235: rt-eskalation: Bugfix -{min,ohne}-sollzeit
  * #10054651: rt-eskalation: Workaround für Option -ohne-bearbeiter:
    + "-ohne-bearbeiter ''" clientseitig filtern
    + andere Argumente erstmal verbieten
  * #465235: rt-eskalation: Bugfix für Verwendung von
    ticket.bearbeiter.pager
  * #465235: NEU:rt-eskalation: QSU-Testjobs
    (Sind etwas experimentell, da sie insbesondere teilweise relative
    Zeitangaben erhalten, was dazu führen kann, dass zwei hintereinander
    stattfindenden Durchläufe unterschiedliche Ergebnisse ergeben.
    Mal sehen, ob das in der Praxis ein Problem ist.)
  * #10054635: Programm stunden-statistik integriert

 -- Martin H. Sluka <fany@noris.net>  Tue, 29 Sep 2009 18:16:28 +0200

kunde (1.2009.6.14) unstable; urgency=low

  * Neue Version...
  * #10022069: kunde: "l /" und "l #..." bei IP-Adressen als Sonderfälle
    betrachten, um fehlerhafte Suchkriterien (wieder) erkennen zu können

 -- Martin H. Sluka <fany@noris.net>  Tue, 29 Sep 2009 13:35:29 +0200

kunde (1.2009.6.13) unstable; urgency=low

  * Neue Version...
  * #465235: Bugfix Dbase::Ticket->kunde und ->queue

 -- Martin H. Sluka <fany@noris.net>  Tue, 29 Sep 2009 13:00:19 +0200

kunde (1.2009.6.12) unstable; urgency=low

  * #10031937: im exim-Acounting: Richtungen separat loggen

 -- Matthias Urlichs <smurf@noris.de>  Tue, 29 Sep 2009 11:35:39 +0200

kunde (1.2009.6.11) unstable; urgency=low

  * #10054329: Bugfix Dbase::Person
  * #547934: gen.hostlist-Beispiel-Template router.db-onehostgroupbydesc
    als Wrapper um router.db-bf umformuliert

 -- Martin H. Sluka <fany@noris.net>  Tue, 29 Sep 2009 10:29:45 +0200

kunde (1.2009.6.10) unstable; urgency=low

  * #10035649: Debug-Modus für process_template() via $ENV{TEMPLATE_DEBUG}
    implementiert
  * #10032057: Dbase::*-ORM-Module überarbeitet
  * #10032057: gen.hostlist:
    + Überarbeitung Beispiel-Templates auf Basis der aktuell produktiv
      verwendeten
    + Überarbeitung QSU-Tests auf Basis der aktuell produktiven Jobs
    + Verwendung von Dbase::Hardware-Objekten

 -- Martin H. Sluka <fany@noris.net>  Mon, 28 Sep 2009 17:29:16 +0200

kunde (1.2009.6.9) unstable; urgency=low

  * Neue Version...

 -- Martin H. Sluka <fany@noris.net>  Wed, 23 Sep 2009 14:05:13 +0200

kunde (1.2009.6.8) unstable; urgency=low

  * Neue Version...
  * #10032057: gen.hostlist: Zuordnungen zu Hardware-Interfaces mit
    exportieren und im Template hostextinfo-hostgroups, das jetzt
    hostextinfo-common heißt, berücksichtigen

 -- Martin H. Sluka <fany@noris.net>  Wed, 23 Sep 2009 13:55:02 +0200

kunde (1.2009.6.7) unstable; urgency=low

  * #10035476: Schönheitsfehler korrigiert wenn kein NIC-Handle angegeben ist.
  * #10035476: kunde: list/handles umgestellt auf noris::Table
  * #10033106: test.ticketgen wurde ohne POPHOME-Option aufgerufen

 -- Matthias Urlichs <smurf@noris.de>  Wed, 23 Sep 2009 13:35:02 +0200

kunde (1.2009.6.6) unstable; urgency=low

  * Neue Version...

 -- Martin H. Sluka <fany@noris.net>  Wed, 23 Sep 2009 10:30:52 +0200

kunde (1.2009.6.5) unstable; urgency=low

  * Neue Version...

 -- Martin H. Sluka <fany@noris.net>  Wed, 23 Sep 2009 10:27:55 +0200

kunde (1.2009.6.4) unstable; urgency=low

  * #10033106: Bugfix qsu/test.ticketgen (Ersetzung @POPHOME@)

 -- Martin H. Sluka <fany@noris.net>  Wed, 23 Sep 2009 10:26:43 +0200

kunde (1.2009.6.3) unstable; urgency=low

  * #10050109: kunde: Vermeidung von redefined-Warnung bei der Ausgabe
    von RIPE-Records
  * #10050109: kunde: Verbesserte Vermeidung von fehlerhaften Records
  * #465235: Nachbesserungen rt-eskalation:
    + Sollzeitauswertung
    + return statt next
  * #10031937: Bei Datenbankfehler das Statement mitloggen
  * #10015458: Test für: FQDN fehlt bei IP-Adresslisten 


=== debian/control ===
Source: kunde
Section: noris/kunde
Priority: extra
Maintainer: Matthias Urlichs <smurf@noris.de>
Build-Depends: bash (>> 3), debhelper (>> 5), lib64c-dev [sparc s390 i386 powerpc], lib64gcc1 [i386 powerpc sparc s390], lib32c-dev [amd64 ppc64], lib32gcc1 [amd64 ppc64], gnupg, libalgorithm-diff-perl, libbusiness-tax-vat-validation-perl, libcache-cache-perl, libchart-perl, libcompress-zlib-perl, libdata-dumpxml-perl, libdate-calc-perl, libdatetime-event-cron-perl, libdbd-mysql-perl, libdbi-perl, libemail-valid-perl, liberror-perl, libgnupg-perl, libhtml-tree-perl, libhtml-scrubber-perl, libhook-lexwrap-perl, libidna-punycode-perl, libio-pty-perl, libio-socket-ssl-perl, libio-string-perl, libipc-run3-perl, libjson-perl, libmail-box-perl, libmailtools-perl, libmime-perl, libmldbm-perl, libmoose-perl, libmysqlclient16-dev | libmysqlclient15-dev | libmysqlclient14-dev | libmysqlclient12-dev | libmysqlclient10-dev | libmysqlclient-dev, libnet-dns-perl, libnet-ip-perl, libnetaddr-ip-perl (>> 4), libnetsaint-noris-perl, libregexp-common-perl, librrds-perl, libscalar-list-utils-perl, libshlock-perl, libsocket6-perl, libstring-shellquote-perl, libtemplate-perl, libterm-readkey-perl, libterm-readline-gnu-perl, libtext-csv-perl, libtext-wrapper-perl, libtie-ixhash-perl, libtime-modules-perl, libtime-period-perl, libtimedate-perl, liburi-find-perl, libwww-mechanize-perl, libxml-grove-perl, libxml-parser-perl, libyaml-perl, perl (>= 5.6), perl-doc, perl-modules, oidentd | ident-server, python-dev, python-mysqldb, yapps2 (>> 2.1.1-16)
Standards-Version: 3.6.1

Package: kunde-common
Architecture: all
Pre-Depends: netbase (>= 4.21)
Depends: ${shlibs:Depends}, liberror-perl, libhtml-scrubber-perl
Conflicts: datenbank-extern, kunde-extern-dev
Replaces: kunde (<< 1.2007.4.13), kunde-htdocs (<< 1.2009.5)
Description: noris-kunde-Datenbank, Gemeinsames
 Kram für kunde und -python und -extern

Package: kunde-bin
Architecture: any
Pre-Depends: netbase (>= 4.21)
Depends: ${shlibs:Depends}
Replaces: kunde (<< 1.2008.9)
Description: noris-kunde-Datenbank, Binaries
 Kompilierte Programme

Package: kunde-32-bin
Architecture: any
Pre-Depends: netbase (>= 4.21)
Depends: libc6
Description: noris-kunde-Datenbank, Binaries
 Kompilierte Programme, 32bit

Package: kunde-64-bin
Architecture: any
Pre-Depends: netbase (>= 4.21)
Depends: libc6
Description: noris-kunde-Datenbank, Binaries
 Kompilierte Programme, 64bit

Package: kunde
Replaces: datenbank, kunde-snmp
Conflicts: datenbank, kunde-snmp
Architecture: all
Pre-Depends: kunde-common (= ${Source-Version})
Depends: ${shlibs:Depends}, kunde-bin (= ${Source-Version}), kunde-rt (= ${Source-Version}), libalgorithm-diff-perl, libbusiness-tax-vat-validation-perl, libchart-perl, libcompress-zlib-perl, libdata-dump-perl, libdatetime-event-cron-perl, libdate-calc-perl, libdbd-mysql-perl, libdbi-perl, libemail-valid-perl, libgnupg-perl, libhook-lexwrap-perl, libidna-punycode-perl, libio-pty-perl, libio-socket-ssl-perl, libio-string-perl, libipc-run3-perl, libjson-perl, libmail-box-perl, libmailtools-perl, libmime-perl, libmldbm-perl, libmoose-perl, libnet-dns-perl, libnet-imap-simple-ssl-perl, libnet-ip-perl, libnetaddr-ip-perl (>> 4), libregexp-common-perl, libscalar-list-utils-perl, libshlock-perl, libsnmp-perl, libsocket6-perl, libstring-shellquote-perl, libtemplate-perl, libterm-readkey-perl, libterm-readline-gnu-perl, libtext-asciitable-perl, libtext-csv-perl, libtext-wrapper-perl, libtie-ixhash-perl, libtime-modules-perl, libtime-period-perl, libtimedate-perl, libwww-mechanize-perl, libxml-grove-perl, libxml-parser-perl, libyaml-perl, perl-doc, perl-modules, oidentd | ident-server, ucspi-tcp, shlock
Recommends: libnetsaint-noris-perl, librrds-perl
Suggests: libapache-mod-perl, kunde-doc, graphviz
Description: noris-kunde-Datenbank, intern
 Standard-Kram: kunde, /usr/pop/bin/*, ...

Package: kunde-extern
Architecture: all
Replaces: datenbank-extern
Conflicts: datenbank-extern
Pre-Depends: kunde-common (= ${Source-Version})
Depends: ${shlibs:Depends}, libcache-cache-perl, libdata-dumpxml-perl, libshlock-perl, libxml-parser-perl, libmime-perl
Description: noris-kunde-Datenbank, extern
 Libraries zum externen Zugriff (via pam, etc.) auf die
 Kunden-Datenbank.

Package: kunde-python
Architecture: all
Pre-Depends: kunde-common (= ${Source-Version})
Depends: python (>= 2.3), ${python:Depends}, kunde (= ${Source-Version}), yapps2-runtime (>> 2.1.1-16), python-mysqldb
Replaces: kunde (<< 1.2007.1.6)
Description: noris-kunde-Datenbank, Python-Kram
 Python-Kram für kunde

Package: kunde-cgibin
Architecture: all
Depends: apache2 | apache, kunde (= ${Source-Version}), libcgi-untaint-perl, libcgi-untaint-hostname-perl, libcgi-untaint-ipaddress-perl, libdata-dumpxml-perl, perl (>= 5.8)
Description: noris-kunde-Datenbank, CGI-Scripts für REST-Backend
 Backend-Scripts für indirekte Datenbankabfragen etc., vgl. RT#214672

Package: kunde-rt
Architecture: all
Pre-Depends: kunde-common (= ${Source-Version})
Depends: ${perl:Depends}, kunde (= ${Source-Version}), libemail-valid-perl, libhtml-tree-perl, libhtml-scrubber-perl, libio-string-perl, libmail-box-perl, libmailtools-perl, libmime-perl, libnetsaint-noris-perl, librrds-perl, libtext-wrapper-perl, libtime-period-perl, liburi-perl, liburi-find-perl, perl-modules
Recommends: libapache-mod-perl, glimpse
Replaces: rt
Conflicts: rt
Description: RT für kunde
 RT-Webinterface für kunde

Package: kunde-doc
Architecture: all
Depends: kunde-common (= ${Source-Version})
Description: Doku für kunde
 Manpages für kunde-Programme

Package: kunde-htdocs
Architecture: all
Depends: kunde-common (= ${Source-Version}), kunde-rt (= ${Source-Version})
Replaces: kunde-cgibin (<< 1.2006.11.12)
Description: kunde-spezifische Dateien auf intra
 Stunden-Interface etc.

Package: kunde-qsu
Architecture: all
Depends: kunde-rt, git-core, dpkg-dev, diff, shlock
Description: kunde-spezifische Dateien auf qsu
 Scripts für die Qualitätssicherungskiste
 .
 Dieses Paket hängt explizit nicht von einer speziellen Version von
 kunde-common ab, damit es nicht automatisch mitgeupdatet wird.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This is the debhelper compatibility version to use.
export DH_COMPAT=4
SHELL=/bin/bash -e -o pipefail

TAGVERSION := $(shell dpkg-parsechangelog -ldebian/changelog | sed -ne 's/^Version: *//p' | sed -e 's/\./_/g')

# OWNER and GROUP
include config.dist

CFLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	INSTALL_PROGRAM += -s
endif

configure: configure-stamp
configure-stamp:
	dh_testdir
	# Add here commands to configure the package.
	# NONE

	@if ! getent group $(GROUP) >/dev/null; then echo TODO: addgroup --system $(GROUP) ; exit 1; fi

	@if ! getent passwd $(OWNER) >/dev/null; then echo TODO: adduser --system --ingroup $(GROUP) --home /usr/pop $(OWNER) ; exit 1; fi

	touch configure-stamp

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

ifeq ($(DEB_HOST_ARCH),i386)
kunde_xx_bin = kunde-64-bin
kunde_xx_arch = amd64
endif

ifeq ($(DEB_HOST_ARCH),amd64)
kunde_xx_bin = kunde-32-bin
kunde_xx_arch = i386
endif


build: build-stamp

build-stamp: configure-stamp 
	dh_testdir

	# Add here commands to compile the package.
	$(MAKE) -f Makefile.Linux compile SUBPYTHON=dbpython
	#/usr/bin/docbook-to-man debian/datenbank.sgml > datenbank.1

	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp python-stamp

	-$(MAKE) clean
	rm -rf debian/tmp

	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs
	
	# install into debian/tmp
	$(MAKE) -f Makefile.Linux install DESTDIR=$(CURDIR)/debian/tmp SUBPYTHON=dbpython
	$(MAKE) man DESTDIR=$(CURDIR)/debian/tmp

# Build architecture-independent files here.
binary-indep: build install
	dh_testdir -i
	dh_testroot -i
	dh_installdocs -n -i
	dh_installchangelogs  -i
	dh_link -i
	dh_strip -i
	dh_compress -i
	dh_fixperms -i
	dh_installdeb -i
	dh_perl -i
	dh_python -i
	
	for p in kunde-doc kunde-cgibin kunde-extern kunde-python kunde-qsu kunde-htdocs ; do \
		dh_movefiles --package=$$p; \
		cd debian/$$p; mkdir -p var/cache; find . -user $(OWNER) -print0 > var/cache/pop.files.$$p; cd ../..; \
	done
	
	#install -d debian/kunde-python/usr/pop/bin
	#install -m 755 -o root -g root bin/db.py debian/kunde-python/usr/pop/bin/db
	#
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i


# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir -a
	dh_testroot -a
#	dh_installdebconf	 -a
	dh_installdocs -n -a
	dh_installexamples -p kunde examples/*
#	dh_installmenu -a
#	dh_installlogrotate -a
#	dh_installemacsen -a
#	dh_installpam -a
#	dh_installmime -a
#	dh_installinit -a
#	dh_installcron -a
#	dh_installman -a
#	dh_installinfo -a
#	dh_undocumented -a
	dh_installchangelogs  -a
	dh_link -a
	dh_strip -a
	dh_compress -a
	dh_fixperms -a
#	dh_makeshlibs -a
	dh_installdeb -a
	dh_perl -a
	dh_python -a

	# Some files are in more than one package
	for p in kunde-common $(kunde_xx_bin) kunde-bin kunde-rt kunde ; do \
		dh_movefiles --package=$$p ; \
		cd debian/$$p; mkdir -p var/cache; find . -user $(OWNER) -print0 > var/cache/pop.files.$$p; cd ../..; \
	done

	dh_shlibdeps -a
	dh_gencontrol -a
ifneq ($(kunde_xx_bin),)
	perl -pi -e 's/^(Package:\s+)$(kunde_xx_bin)/$${1}kunde-bin/; s/^(Architecture:\s+)$(DEB_HOST_ARCH)/$${1}$(kunde_xx_arch)/; s/^(Depends:.*\blibc)-$(kunde_xx_arch)\b/$${1}/' debian/$(kunde_xx_bin)/DEBIAN/control
	find debian/$(kunde_xx_bin) -type f | while read f ; do g="$$(echo $$f | sed -e 's/32$$//g' -e 's/64$$//g')"; [ "$$f" = "$$g" ] || mv "$$f" "$$g" ; done
endif
#Package: kunde-64-bin
#Version: 1.2008.8.12
#Section: noris/kunde
#Priority: extra
#Architecture: i386
#Pre-Depends: netbase (>= 4.21)
#Depends: libc6-amd64 (>= 2.3.5-1)
#Installed-Size: 168
#Maintainer: Matthias Urlichs <smurf@noris.de>
#Source: kunde
#Description: noris-kunde-Datenbank, Binaries

	dh_md5sums -a
	dh_builddeb kunde-bin $(kunde_xx_bin)
ifneq ($(kunde_xx_bin),)
	perl -pi -e 's/^$(kunde_xx_bin)_(.*)_$(DEB_HOST_ARCH)\.deb/kunde-bin_$${1}_$(kunde_xx_arch).deb/' debian/files
endif
#kunde-64-bin_1.2008.8.12_i386.deb noris/kunde extra

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure

version:
	@echo ${TAGVERSION}
